<?php
// Do not edit this file, instead use the new dashboard editor in the expert section.
// New CSS Overlay for Pi-Star, to allow setting the variables from outside this file.
// Output CSS and not plain text
header("Content-type: text/css");
// Check if the config file exists
if (file_exists('/etc/pistar-css.ini')) {
    // Use the values from the file
    $piStarCssFile = '/etc/pistar-css.ini';
	if (fopen($piStarCssFile,'r')) { $piStarCss = parse_ini_file($piStarCssFile, true); }
    
    // Set the Values from the config file
    $backgroundPage = $piStarCss['Background']['Page'];		// usually off-white
    $backgroundContent = $piStarCss['Background']['Content'];   // The White background in the content section
    $backgroundBanners = $piStarCss['Background']['Banners'];   // The ubiquitous Pi-Star Red
    $textBanners = $piStarCss['Text']['Banners'];            	// Usually white
    $bannerDropShaddows = $piStarCss['Text']['BannersDrop'];    // Banner drop shaddow colour
    $tableHeadDropShaddow = $piStarCss['Tables']['HeadDrop'];   // Table Headder drop shaddows
    $textContent = $piStarCss['Content']['Text'];            	// Used for the section titles
    $tableRowEvenBg = $piStarCss['Tables']['BgEven']; 		// Table Row BG Colour (Even)
    $tableRowOddBg = $piStarCss['Tables']['BgOdd'];		// Table Row BG Colour (Odd)
    
} else {
    // Default values
    $backgroundPage = "edf0f5";         // usually off-white
    $backgroundContent = "ffffff";      // The White background in the content section
    $backgroundBanners = "dd4b39";      // The ubiquitous Pi-Star Red
    $textBanners = "ffffff";            // Usually white
    $bannerDropShaddows = "303030";     // Banner drop shaddow colour
    $tableHeadDropShaddow = "8b0000";   // Table Headder drop shaddows
    $textContent = "000000";            // Used for the section titles
    $tableRowEvenBg = "f7f7f7";		// Table Row BG Colour (Even)
    $tableRowOddBg = "d0d0d0";		// Table Row BG Colour (Odd)
}
?>
body {
	background-color: #<?php echo $backgroundBanners; ?>;
}

.red {
	color:red;
}

.green {
	color:green;
}

.network {
        border:1px solid;
	text-align:left;
        padding-top:5px;
        padding-left:5px;
	background-color: #<?php echo $tableRowOddBg; ?>;
}

.tableft {
	display:inline-block;
	text-align:right;
	width:120px;
}

textarea {
        width:699px;
        height:499px;
}

input.button {
        width:80%;
        border:1px solid;
}

input[type=text],input[type=password] {
	border:1px solid;
}

input[type=button],input[type=submit] {
	border:1px solid;
	border-radius:5px;
}

.infoheader {
	width:100%;
	text-align:center;
	margin-top:10px;
	border-bottom: 1px solid;
}

.infobox {
	background-color: #<?php echo $backgroundBanners; ?>;
	font-weight: bold;
	width:100%;
}

.intinfo {
	background-color: #<?php echo $tableRowOddBg; ?>;
	color: #<?php echo $textContent; ?>;
	width: 398px;
	text-align: left;
	border-right: 1px solid;
	border-left: 1px solid;
	float: left;
        border-bottom:1px solid;
	font-family: "Courier New", Courier, monospace;
}

.wifiinfo {
	background-color: #<?php echo $tableRowOddBg; ?>;
	color: #<?php echo $textContent; ?>;
	margin: 0 0 0 400px;
	border-right: 1px solid;
	text-align: left;
        border-bottom:1px solid;
	font-family: "Courier New", Courier, monospace;
}

.intheader {
	background-color: #<?php echo $backgroundBanners; ?>;
	color: #<?php echo $textBanners; ?>;
	text-align:center;
	width:100%;
	font-weight: bold;
}

.intfooter {
	background-color: #<?php echo $backgroundBanners; ?>;
	color: #<?php echo $textBanners; ?>;
	width:100%;
	border-top:1px solid;
	float:left;
	text-align:center;
}

.tail {
	background-color: #<?php echo $backgroundBanners; ?>;
	color: #<?php echo $backgroundBanners; ?>;
	width:100%;
}
